<?php
/*
Plugin Name: Google Ajax Related Search - Witty Sparks
Plugin URI: http://www.wittysparks.com
Description: Adds a Google AJAX Related Search (Tabbed based interface search based on the article title). Example found in every article page <a href="http://wittysparks.com">here</a>. Options include searching your site through Google Blog Search and/or straight up Google, a second search option is available that is perfect for flickr. Widgetized for your pleasure. MAKE SURE TO <a href="options-general.php?page=Google-AJAX-Search_WS.php">CONFIGURE</a> your options and enter your API key.
Author: http://wittysparks.com
Version: 1.0
Stable tag: 1.0
Author URI: http://wittysparks.com

Installation:
	1. Download the plugin and unzip it (didn't you already do this?).
	2. Put the 'Google-AJAX-Search_WS.php' file into your wp-content/plugins/ directory.
	3. Go to the Plugins page in your WordPress Administration area and click 'Activate' next to Google Ajax Related Search - WittySparks.
	4. Go to Options > Google Ajax Search to configure your settings and click 'save'.
		a. You will need an API key first. http://code.google.com/apis/ajaxsearch/signup.html
		b. All other options are optional.
	5. You can place the widget not only in the side bars, you can have it at any place where you place the widget function <?php custom_search_ws(); ?> or use the Sidebar widget controller and drag and drop the Google AJAX Related Search :)
	6. Have fun and if you can contribute (see notes).
	7. If you really like our effort you can even donate us by clicking on the Donate Paypal button placed in the side bar at http://www.wittysparks.com

Notes:
	- If you know how to modify this plugin so you don't have to modify the templates body tag contact me at sravkum@gmail.com
	

Version history:

- 1.0
This is our first wordpress plugin :). Feel free to edit the code and do some enhancement for the same.

*/

/*
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
*/


function googleajaxsearch_ws_header() {
	$googleajaxsearch_googleAjaxSearchKey = get_option("googleajaxsearch_googleAjaxSearchKey");
	$googleajaxsearch_tabhActive = get_option("googleajaxsearch_tabhActive");
	$googleajaxsearch_tabhActive = get_option("googleajaxsearch_tabhInActive");
	$googleajaxsearch_tabhActive = get_option("googleajaxsearch_tabhInActiveFC");
	$googleajaxsearch_SearchResultLink = get_option("googleajaxsearch_SearchResultLink");

	?>

	<!-- Google Ajax Search <script src="http://www.google.com/uds/api?file=uds.js&v=1.0&key=ABQIAAAAT1b6ym0gCD4EGfiloA_BpRRYgLmrSqv75xQwBWMDLG8gePPQ7xS0juqf08AuWBBKwoZ6uk6glFNRuA" type="text/javascript"></script>-->
    <script src="http://www.google.com/uds/api?file=uds.js&v=1.0&key=<?php echo get_option('googleajaxsearch_googleAjaxSearchKey'); ?>" type="text/javascript"></script>
    <link href="http://www.google.com/uds/css/gsearch.css" rel="stylesheet" type="text/css"/>

    <style type="text/css">
		.gsc-control {
			width: 100% !important;
			overflow: hidden;
		}
		table.search-control {
			width : 100%;
		}
      table.search-control .gsc-control {
        width : 100% !important;
      }
	  /*Start For tabs css overwrite*/
	  .gsc-tabsArea .gs-spacer {
		  margin-right : 0px !important;
	  }
	  .gsc-tabHeader {
		  padding-left: 5px !important;
		  padding-right: 5px !important;
	  }
	  /*Start For Active Tab text color css overwrite #980000*/
	  .gsc-tabHeader.gsc-tabhActive {
			border-left: 1px solid #<?php echo get_option('googleajaxsearch_tabhActive'); ?> !important;
			border-right: 1px solid #<?php echo get_option('googleajaxsearch_tabhActive'); ?> !important;
			border-top: 2px solid #<?php echo get_option('googleajaxsearch_tabhActive'); ?> !important;
		  color: #<?php echo get_option('googleajaxsearch_tabhActive'); ?> !important;
      }
	  /*Start For InActive Tab text color css overwrite #e9e9e9*/
	  .gsc-tabHeader.gsc-tabhInactive {
			border-left: 1px solid #<?php echo get_option('googleajaxsearch_tabhInactive'); ?> !important;
			border-right: 1px solid #<?php echo get_option('googleajaxsearch_tabhInactive'); ?> !important;
			border-top: 2px solid #<?php echo get_option('googleajaxsearch_tabhInactive'); ?> !important;
			background: #<?php echo get_option('googleajaxsearch_tabhInactive'); ?> !important;
			color: #<?php echo get_option('googleajaxsearch_tabhInactiveFC'); ?> !important;
	  }
	  /*End For tabs css overwrite*/

	  /*Start For Link css overwrite #980000*/
	  .search-control a, .search-control a strong, .search-control strong {
		  color: #<?php echo get_option('googleajaxsearch_SearchResultLink'); ?> !important;
	  }
	  .search-control a:hover {
		  text-decoration : underline !important;
	  }
	  /*End For Link css overwrite*/


      td {
        vertical-align : top;
      }
      /* Disable built in search forms */
      .gsc-control form.gsc-search-box {
        display : none;
      }
      /* restrict global search form width */
      #searchForm {
        width : 300px;
      }
      #leftSearchControl .gsc-resultsRoot {
        padding-top : 6px;
      }
      /* for demonstration purposes ONLY. This is not ok by the terms */
      #rightSearchControl .gsc-ad-box {
        display : none;
      }
      /* long form visible urls should be on */
      .gsc-webResult div.gs-visibleUrl-long {
        display : block;
      }
      .gsc-webResult div.gs-visibleUrl-short {
        display : none;
      }
    </style>
    <script type="text/javascript">

      // the se class encapsulates a left and right search control
      // both controls are driven by a shared search form
      function se() {
        var sFormDiv = document.getElementById("searchForm");
        var leftScDiv = document.getElementById("leftSearchControl");
        var rightScDiv = document.getElementById("rightSearchControl");

        // create a left, right search control
        // create a custom search form
        this.leftControl = new GSearchControl();
        this.rightControl = new GSearchControl();
        this.searchForm = new GSearchForm(true, sFormDiv);

        // bind clear and submit functions
        this.searchForm.setOnSubmitCallback(this, se.prototype.onSubmit);
        this.searchForm.setOnClearCallback(this, se.prototype.onClear);

        // set up for large result sets
        this.leftControl.setResultSetSize(GSearch.LARGE_RESULTSET);
        this.rightControl.setResultSetSize(GSearch.LARGE_RESULTSET);

        var searcher;
        var options;

        // configure left control
        // vertical layout, image and blog

        // configure right control
        // tabbed layout image, web, news, video
        this.rightControl.addSearcher(new GwebSearch());
        this.rightControl.addSearcher(new GblogSearch());
        this.rightControl.addSearcher(new GnewsSearch());
        this.rightControl.addSearcher(new GimageSearch());

        var drawOptions = new GdrawOptions();
        drawOptions.setDrawMode(GSearchControl.DRAW_MODE_TABBED);

        this.rightControl.setNoResultsString(GSearchControl.NO_RESULTS_DEFAULT_STRING);
        this.leftControl.setNoResultsString(GSearchControl.NO_RESULTS_DEFAULT_STRING);
        this.leftControl.draw(leftScDiv);
        this.rightControl.draw(rightScDiv, drawOptions);

        // execute a starter search
        this.searchForm.execute("<?php the_title(); ?>");

      }

      // when the form fires a submit, grab its
      // value and call the left and right control
      se.prototype.onSubmit = function(form) {
        var q = form.input.value;
        if (q && q!= "") {
          this.leftControl.execute(q);
          this.rightControl.execute(q);
        }
        return false;
      }

      // when the form fires a clear, call the left and right control
      se.prototype.onClear = function(form) {
        this.leftControl.clearAllResults();
        this.rightControl.clearAllResults();
        form.input.value = "";
        return false;
      }

      function OnLoad() {
        new se();
      }
      GSearch.setOnLoadCallback(OnLoad);
    </script>


		
	<!-- Google Maps Plugin for WordPress (end) -->

<?php } // end googleajaxsearch_ws_header()

// Start GWS WS
//admin panel

function googleajaxsearch_ws_adminPanel() {
		add_options_page('Google Ajax Search - WS', 'Google Ajax Search - WS', 10,
			basename(__FILE__), 'googleajaxsearch_ws_optionsSubpanel');
}
function googleajaxsearch_ws_optionsSubpanel() {
	if($_POST['action'] == "save") {
		echo "<div class=\"updated fade\" id=\"limitcatsupdatenotice\"><p>" . __("Configuration <strong>updated</strong>.") . "</p></div>";
		//updating stuff..
		update_option("googleajaxsearch_googleAjaxSearchKey", $_POST["key"]);
		update_option("googleajaxsearch_tabhActive", $_POST["tabhActiveFontColor"]);
		update_option("googleajaxsearch_tabhInActive", $_POST["tabhInActive"]);
		update_option("googleajaxsearch_tabhInActiveFC", $_POST["tabhInActiveFontColor"]);
		update_option("googleajaxsearch_SearchResultLink", $_POST["SearchResultLink"]);
				
		$googleajaxsearch_googleAjaxSearchKey   = get_option("googleajaxsearch_googleAjaxSearchKey");
		$googleajaxsearch_tabhActive = get_option("googleajaxsearch_tabhActive");
		$googleajaxsearch_SearchResultLink = get_option("googleajaxsearch_SearchResultLink");
		$googleajaxsearch_tabhInActive = get_option("googleajaxsearch_tabhInActive");
		$googleajaxsearch_tabhInActiveFC = get_option("googleajaxsearch_tabhInActiveFC");
	    }

		?>
		
		<div class="wrap">
		<h2>Google AJAX Related Search - WittySparks.com</h2>	
		<form method="post">
	    <fieldset class="options">
		<legend>Configuration</legend>
		<table class="optiontable">
			
		<tr valign="top">
		<th scope="row">
		<label for="gAJAXKey"><strong>REQUIRED:</strong><br/>API Key</label>
		</th>
		<td>
			
		<input type="text" name="key" size="90" value='<?php echo get_option('googleajaxsearch_googleAjaxSearchKey'); ?>'>
		<br/>
		Get a Google AJAX Search API key <a href="http://code.google.com/apis/ajaxsearch/signup.html" target="_blank">here</a>.
		</td>
		</tr>
		
		</table>
		</fieldset>

		<fieldset class="options">
		<legend>Style Configuration</legend>
		<table class="optiontable">
		
		<tr valign="top">
		<th scope="row">
		<label for="gAJAXtitle">Active Tab Font Color</label>
		</th>
		<td>		
		#<input type="text" name="tabhActiveFontColor" size="6" value="<?php echo get_option('googleajaxsearch_tabhActive'); ?>"><br> (default: #980000)
		</td>
		</tr>
		
		<tr valign="top">
		<th scope="row">
		<label for="gAJAXtitle">InActive Tab Background Color</label>
		</th>
		<td>		
		#<input type="text" name="tabhInActive" size="6" value="<?php echo get_option('googleajaxsearch_tabhInActive'); ?>"><br> (default: #e9e9e9)
		</td>
		</tr>
		
		<tr valign="top">
		<th scope="row">
		<label for="gAJAXtitle">InActive Tab Font Color</label>
		</th>
		<td>		
		#<input type="text" name="tabhInActiveFontColor" size="6" value="<?php echo get_option('googleajaxsearch_tabhInActiveFC'); ?>"><br> (default: #676767)
		</td>
		</tr>
		
		<tr valign="top">
		<th scope="row">
		<label for="gAJAXwidth">URL Link Color</label>
		</th>
		<td>		
		#<input type="text" name="SearchResultLink" size="6" value="<?php echo get_option('googleajaxsearch_SearchResultLink'); ?>"><br> (default: #980000)		
			<br/>
		</td>
		</tr>


		
		
		
		</table>
	    </fieldset>

		<fieldset class="options">
		<div class="submit">
		<input type="hidden" name="action" value="save">
		<input type="submit" value="Save">
		</div>
		</fieldset>
		</form>
		<br><br>
	
	</div>
		<?php } // end googleajaxsearch_ws_optionsSubpanel()


// End GWS WS

/* Start Side bar Widget */
function widget_gajaxsearch_ws_init()
{
	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') ) return;

	register_sidebar_widget('Google AJAX Search, WittySparks', 'widget_gajaxsearch_ws');
	register_widget_control('Google AJAX Search, WittySparks', 'widget_gajaxsearch_ws_control');
}

function widget_gajaxsearch_ws($args)
{
	extract($args);

	$options = get_option('widget_gajaxsearch_ws');
	$title = $options['title'];

	echo $before_widget;
	echo $before_title . $title . $after_title;

	custom_search_ws();

	echo $after_widget;
}


function widget_gajaxsearch_ws_control()
{
	$options = $newoptions = get_option('widget_gajaxsearch_ws');

	if ( $_POST['widget_gajaxsearch_ws_title'] ) {
		$newoptions['title'] = strip_tags(stripslashes($_POST['widget_gajaxsearch_ws_title']));
	}

	if ( $options != $newoptions ) {
		$options = $newoptions;
		update_option('widget_gajaxsearch_ws', $options);
	}

	?>
			<p><label for="widget_gajaxsearch_ws_title">Title: <input type="text" style="width: 250px;" id="widget_gajaxsearch_ws_title" name="widget_gajaxsearch_ws_title" value="<?php echo htmlspecialchars($options['title']); ?>" /></label></p>
			<input type="hidden" name="widget_gajaxsearch_ws_submit" id="widget_gajaxsearch_ws_submit" value="1" />
<?
}
/* End Side bar Widget */














function custom_search_ws() {
	?>
	
	<div id="searchForm" style="display:none;">Loading...</div>
	<table class="search-control">
      <td class="right">
        <div id="rightSearchControl" class="search-control">Loading...</div>
      </td>
    </table>
	
	<?php }  // end custom_search_ws()

// Run our code later in case this loads prior to any required plugins.
add_action('plugins_loaded','widget_gajaxsearch_ws_init');

//user hooks
add_action('wp_head', 'googleajaxsearch_ws_header');

//admin hooks
add_action('admin_menu', 'googleajaxsearch_ws_adminPanel');

?>